t: redirect stderr GIT_TRACE to descriptor 4
[git] / t / test-lib.sh
1 # Test framework for git.  See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
20
21 # Test the binaries we have just built.  The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25         # We allow tests to override this, in case they want to run tests
26         # outside of t/, e.g. for running tests on the test library
27         # itself.
28         TEST_DIRECTORY=$(pwd)
29 else
30         # ensure that TEST_DIRECTORY is an absolute path so that it
31         # is valid even if the current working directory is changed
32         TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
33 fi
34 if test -z "$TEST_OUTPUT_DIRECTORY"
35 then
36         # Similarly, override this to store the test-results subdir
37         # elsewhere
38         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39 fi
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
45 if test $? != 1
46 then
47         echo >&2 'error: you do not seem to have built git yet.'
48         exit 1
49 fi
50
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
53
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
57 done,*)
58         # do not redirect again
59         ;;
60 *' --tee '*|*' --va'*)
61         mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62         BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63         (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64          echo $? > $BASE.exit) | tee $BASE.out
65         test "$(cat $BASE.exit)" = 0
66         exit
67         ;;
68 esac
69
70 # For repeatability, reset the environment to known value.
71 LANG=C
72 LC_ALL=C
73 PAGER=cat
74 TZ=UTC
75 TERM=dumb
76 export LANG LC_ALL PAGER TERM TZ
77 EDITOR=:
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
80 # deriving from the command substitution clustered with the other
81 # ones.
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83         my @env = keys %ENV;
84         my $ok = join("|", qw(
85                 TRACE
86                 DEBUG
87                 USE_LOOKUP
88                 TEST
89                 .*_TEST
90                 PROVE
91                 VALGRIND
92                 UNZIP
93                 PERF_
94                 CURL_VERBOSE
95         ));
96         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97         print join("\n", @vars);
98 ')
99 unset XDG_CONFIG_HOME
100 unset GITPERLLIB
101 GIT_AUTHOR_EMAIL=author@example.com
102 GIT_AUTHOR_NAME='A U Thor'
103 GIT_COMMITTER_EMAIL=committer@example.com
104 GIT_COMMITTER_NAME='C O Mitter'
105 GIT_MERGE_VERBOSITY=5
106 GIT_MERGE_AUTOEDIT=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
110 export EDITOR
111
112 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113 GIT_TRACE_BARE=1
114 export GIT_TRACE_BARE
115
116 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117 then
118         GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119         export GIT_INDEX_VERSION
120 fi
121
122 # Add libc MALLOC and MALLOC_PERTURB test
123 # only if we are not executing the test with valgrind
124 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
125    test -n "$TEST_NO_MALLOC_CHECK"
126 then
127         setup_malloc_check () {
128                 : nothing
129         }
130         teardown_malloc_check () {
131                 : nothing
132         }
133 else
134         setup_malloc_check () {
135                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136                 export MALLOC_CHECK_ MALLOC_PERTURB_
137         }
138         teardown_malloc_check () {
139                 unset MALLOC_CHECK_ MALLOC_PERTURB_
140         }
141 fi
142
143 : ${ASAN_OPTIONS=detect_leaks=0}
144 export ASAN_OPTIONS
145
146 # Protect ourselves from common misconfiguration to export
147 # CDPATH into the environment
148 unset CDPATH
149
150 unset GREP_OPTIONS
151 unset UNZIP
152
153 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
154 1|2|true)
155         GIT_TRACE=4
156         ;;
157 esac
158
159 # Convenience
160 #
161 # A regexp to match 5 and 40 hexdigits
162 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
163 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
164
165 # Zero SHA-1
166 _z40=0000000000000000000000000000000000000000
167
168 # Line feed
169 LF='
170 '
171
172 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
173 # when case-folding filenames
174 u200c=$(printf '\342\200\214')
175
176 export _x05 _x40 _z40 LF u200c
177
178 # Each test should start with something like this, after copyright notices:
179 #
180 # test_description='Description of this test...
181 # This test checks if command xyzzy does the right thing...
182 # '
183 # . ./test-lib.sh
184
185 unset color
186 while test "$#" -ne 0
187 do
188         case "$1" in
189         -d|--d|--de|--deb|--debu|--debug)
190                 debug=t; shift ;;
191         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
192                 immediate=t; shift ;;
193         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
194                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
195         -r)
196                 shift; test "$#" -ne 0 || {
197                         echo 'error: -r requires an argument' >&2;
198                         exit 1;
199                 }
200                 run_list=$1; shift ;;
201         --run=*)
202                 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
203         -h|--h|--he|--hel|--help)
204                 help=t; shift ;;
205         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
206                 verbose=t; shift ;;
207         --verbose-only=*)
208                 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
209                 shift ;;
210         -q|--q|--qu|--qui|--quie|--quiet)
211                 # Ignore --quiet under a TAP::Harness. Saying how many tests
212                 # passed without the ok/not ok details is always an error.
213                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
214         --with-dashes)
215                 with_dashes=t; shift ;;
216         --no-color)
217                 color=; shift ;;
218         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
219                 valgrind=memcheck
220                 shift ;;
221         --valgrind=*)
222                 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
223                 shift ;;
224         --valgrind-only=*)
225                 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
226                 shift ;;
227         --tee)
228                 shift ;; # was handled already
229         --root=*)
230                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
231                 shift ;;
232         -x)
233                 trace=t
234                 verbose=t
235                 shift ;;
236         *)
237                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
238         esac
239 done
240
241 if test -n "$valgrind_only"
242 then
243         test -z "$valgrind" && valgrind=memcheck
244         test -z "$verbose" && verbose_only="$valgrind_only"
245 elif test -n "$valgrind"
246 then
247         verbose=t
248 fi
249
250 error () {
251         say_color error "error: $*"
252         GIT_EXIT_OK=t
253         exit 1
254 }
255
256 say () {
257         say_color info "$*"
258 }
259
260 test "${test_description}" != "" ||
261 error "Test script did not set test_description."
262
263 if test "$help" = "t"
264 then
265         printf '%s\n' "$test_description"
266         exit 0
267 fi
268
269 exec 5>&1
270 exec 6<&0
271 if test "$verbose" = "t"
272 then
273         exec 4>&2 3>&1
274 else
275         exec 4>/dev/null 3>/dev/null
276 fi
277
278 test_failure=0
279 test_count=0
280 test_fixed=0
281 test_broken=0
282 test_success=0
283
284 test_external_has_tap=0
285
286 die () {
287         code=$?
288         if test -n "$GIT_EXIT_OK"
289         then
290                 exit $code
291         else
292                 echo >&5 "FATAL: Unexpected exit with code $code"
293                 exit 1
294         fi
295 }
296
297 GIT_EXIT_OK=
298 trap 'die' EXIT
299 trap 'exit $?' INT
300
301 # The user-facing functions are loaded from a separate file so that
302 # test_perf subshells can have them too
303 . "$TEST_DIRECTORY/test-lib-functions.sh"
304
305 # You are not expected to call test_ok_ and test_failure_ directly, use
306 # the test_expect_* functions instead.
307
308 test_ok_ () {
309         test_success=$(($test_success + 1))
310         say_color "" "ok $test_count - $@"
311 }
312
313 test_failure_ () {
314         test_failure=$(($test_failure + 1))
315         say_color error "not ok $test_count - $1"
316         shift
317         printf '%s\n' "$*" | sed -e 's/^/#      /'
318         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
319 }
320
321 test_known_broken_ok_ () {
322         test_fixed=$(($test_fixed+1))
323         say_color error "ok $test_count - $@ # TODO known breakage vanished"
324 }
325
326 test_known_broken_failure_ () {
327         test_broken=$(($test_broken+1))
328         say_color warn "not ok $test_count - $@ # TODO known breakage"
329 }
330
331 test_debug () {
332         test "$debug" = "" || eval "$1"
333 }
334
335 match_pattern_list () {
336         arg="$1"
337         shift
338         test -z "$*" && return 1
339         for pattern_
340         do
341                 case "$arg" in
342                 $pattern_)
343                         return 0
344                 esac
345         done
346         return 1
347 }
348
349 match_test_selector_list () {
350         title="$1"
351         shift
352         arg="$1"
353         shift
354         test -z "$1" && return 0
355
356         # Both commas and whitespace are accepted as separators.
357         OLDIFS=$IFS
358         IFS='   ,'
359         set -- $1
360         IFS=$OLDIFS
361
362         # If the first selector is negative we include by default.
363         include=
364         case "$1" in
365                 !*) include=t ;;
366         esac
367
368         for selector
369         do
370                 orig_selector=$selector
371
372                 positive=t
373                 case "$selector" in
374                         !*)
375                                 positive=
376                                 selector=${selector##?}
377                                 ;;
378                 esac
379
380                 test -z "$selector" && continue
381
382                 case "$selector" in
383                         *-*)
384                                 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
385                                 then
386                                         echo "error: $title: invalid non-numeric in range" \
387                                                 "start: '$orig_selector'" >&2
388                                         exit 1
389                                 fi
390                                 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
391                                 then
392                                         echo "error: $title: invalid non-numeric in range" \
393                                                 "end: '$orig_selector'" >&2
394                                         exit 1
395                                 fi
396                                 ;;
397                         *)
398                                 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
399                                 then
400                                         echo "error: $title: invalid non-numeric in test" \
401                                                 "selector: '$orig_selector'" >&2
402                                         exit 1
403                                 fi
404                 esac
405
406                 # Short cut for "obvious" cases
407                 test -z "$include" && test -z "$positive" && continue
408                 test -n "$include" && test -n "$positive" && continue
409
410                 case "$selector" in
411                         -*)
412                                 if test $arg -le ${selector#-}
413                                 then
414                                         include=$positive
415                                 fi
416                                 ;;
417                         *-)
418                                 if test $arg -ge ${selector%-}
419                                 then
420                                         include=$positive
421                                 fi
422                                 ;;
423                         *-*)
424                                 if test ${selector%%-*} -le $arg \
425                                         && test $arg -le ${selector#*-}
426                                 then
427                                         include=$positive
428                                 fi
429                                 ;;
430                         *)
431                                 if test $arg -eq $selector
432                                 then
433                                         include=$positive
434                                 fi
435                                 ;;
436                 esac
437         done
438
439         test -n "$include"
440 }
441
442 maybe_teardown_verbose () {
443         test -z "$verbose_only" && return
444         exec 4>/dev/null 3>/dev/null
445         verbose=
446 }
447
448 last_verbose=t
449 maybe_setup_verbose () {
450         test -z "$verbose_only" && return
451         if match_pattern_list $test_count $verbose_only
452         then
453                 exec 4>&2 3>&1
454                 # Emit a delimiting blank line when going from
455                 # non-verbose to verbose.  Within verbose mode the
456                 # delimiter is printed by test_expect_*.  The choice
457                 # of the initial $last_verbose is such that before
458                 # test 1, we do not print it.
459                 test -z "$last_verbose" && echo >&3 ""
460                 verbose=t
461         else
462                 exec 4>/dev/null 3>/dev/null
463                 verbose=
464         fi
465         last_verbose=$verbose
466 }
467
468 maybe_teardown_valgrind () {
469         test -z "$GIT_VALGRIND" && return
470         GIT_VALGRIND_ENABLED=
471 }
472
473 maybe_setup_valgrind () {
474         test -z "$GIT_VALGRIND" && return
475         if test -z "$valgrind_only"
476         then
477                 GIT_VALGRIND_ENABLED=t
478                 return
479         fi
480         GIT_VALGRIND_ENABLED=
481         if match_pattern_list $test_count $valgrind_only
482         then
483                 GIT_VALGRIND_ENABLED=t
484         fi
485 }
486
487 # This is a separate function because some tests use
488 # "return" to end a test_expect_success block early
489 # (and we want to make sure we run any cleanup like
490 # "set +x").
491 test_eval_inner_ () {
492         # Do not add anything extra (including LF) after '$*'
493         eval "
494                 test \"$trace\" = t && set -x
495                 $*"
496 }
497
498 test_eval_ () {
499         # We run this block with stderr redirected to avoid extra cruft
500         # during a "-x" trace. Once in "set -x" mode, we cannot prevent
501         # the shell from printing the "set +x" to turn it off (nor the saving
502         # of $? before that). But we can make sure that the output goes to
503         # /dev/null.
504         #
505         # The test itself is run with stderr put back to &4 (so either to
506         # /dev/null, or to the original stderr if --verbose was used).
507         {
508                 test_eval_inner_ "$@" </dev/null >&3 2>&4
509                 test_eval_ret_=$?
510                 if test "$trace" = t
511                 then
512                         set +x
513                         if test "$test_eval_ret_" != 0
514                         then
515                                 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
516                         fi
517                 fi
518         } 2>/dev/null
519         return $test_eval_ret_
520 }
521
522 test_run_ () {
523         test_cleanup=:
524         expecting_failure=$2
525         setup_malloc_check
526         test_eval_ "$1"
527         eval_ret=$?
528         teardown_malloc_check
529
530         if test -z "$immediate" || test $eval_ret = 0 ||
531            test -n "$expecting_failure" && test "$test_cleanup" != ":"
532         then
533                 setup_malloc_check
534                 test_eval_ "$test_cleanup"
535                 teardown_malloc_check
536         fi
537         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
538         then
539                 echo ""
540         fi
541         return "$eval_ret"
542 }
543
544 test_start_ () {
545         test_count=$(($test_count+1))
546         maybe_setup_verbose
547         maybe_setup_valgrind
548 }
549
550 test_finish_ () {
551         echo >&3 ""
552         maybe_teardown_valgrind
553         maybe_teardown_verbose
554 }
555
556 test_skip () {
557         to_skip=
558         skipped_reason=
559         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
560         then
561                 to_skip=t
562                 skipped_reason="GIT_SKIP_TESTS"
563         fi
564         if test -z "$to_skip" && test -n "$test_prereq" &&
565            ! test_have_prereq "$test_prereq"
566         then
567                 to_skip=t
568
569                 of_prereq=
570                 if test "$missing_prereq" != "$test_prereq"
571                 then
572                         of_prereq=" of $test_prereq"
573                 fi
574                 skipped_reason="missing $missing_prereq${of_prereq}"
575         fi
576         if test -z "$to_skip" && test -n "$run_list" &&
577                 ! match_test_selector_list '--run' $test_count "$run_list"
578         then
579                 to_skip=t
580                 skipped_reason="--run"
581         fi
582
583         case "$to_skip" in
584         t)
585                 say_color skip >&3 "skipping test: $@"
586                 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
587                 : true
588                 ;;
589         *)
590                 false
591                 ;;
592         esac
593 }
594
595 # stub; perf-lib overrides it
596 test_at_end_hook_ () {
597         :
598 }
599
600 test_done () {
601         GIT_EXIT_OK=t
602
603         if test -z "$HARNESS_ACTIVE"
604         then
605                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
606                 mkdir -p "$test_results_dir"
607                 base=${0##*/}
608                 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
609
610                 cat >>"$test_results_path" <<-EOF
611                 total $test_count
612                 success $test_success
613                 fixed $test_fixed
614                 broken $test_broken
615                 failed $test_failure
616
617                 EOF
618         fi
619
620         if test "$test_fixed" != 0
621         then
622                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
623         fi
624         if test "$test_broken" != 0
625         then
626                 say_color warn "# still have $test_broken known breakage(s)"
627         fi
628         if test "$test_broken" != 0 || test "$test_fixed" != 0
629         then
630                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
631                 msg="remaining $test_remaining test(s)"
632         else
633                 test_remaining=$test_count
634                 msg="$test_count test(s)"
635         fi
636         case "$test_failure" in
637         0)
638                 # Maybe print SKIP message
639                 if test -n "$skip_all" && test $test_count -gt 0
640                 then
641                         error "Can't use skip_all after running some tests"
642                 fi
643                 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
644
645                 if test $test_external_has_tap -eq 0
646                 then
647                         if test $test_remaining -gt 0
648                         then
649                                 say_color pass "# passed all $msg"
650                         fi
651                         say "1..$test_count$skip_all"
652                 fi
653
654                 test -d "$remove_trash" &&
655                 cd "$(dirname "$remove_trash")" &&
656                 rm -rf "$(basename "$remove_trash")"
657
658                 test_at_end_hook_
659
660                 exit 0 ;;
661
662         *)
663                 if test $test_external_has_tap -eq 0
664                 then
665                         say_color error "# failed $test_failure among $msg"
666                         say "1..$test_count"
667                 fi
668
669                 exit 1 ;;
670
671         esac
672 }
673
674 if test -n "$valgrind"
675 then
676         make_symlink () {
677                 test -h "$2" &&
678                 test "$1" = "$(readlink "$2")" || {
679                         # be super paranoid
680                         if mkdir "$2".lock
681                         then
682                                 rm -f "$2" &&
683                                 ln -s "$1" "$2" &&
684                                 rm -r "$2".lock
685                         else
686                                 while test -d "$2".lock
687                                 do
688                                         say "Waiting for lock on $2."
689                                         sleep 1
690                                 done
691                         fi
692                 }
693         }
694
695         make_valgrind_symlink () {
696                 # handle only executables, unless they are shell libraries that
697                 # need to be in the exec-path.
698                 test -x "$1" ||
699                 test "# " = "$(head -c 2 <"$1")" ||
700                 return;
701
702                 base=$(basename "$1")
703                 symlink_target=$GIT_BUILD_DIR/$base
704                 # do not override scripts
705                 if test -x "$symlink_target" &&
706                     test ! -d "$symlink_target" &&
707                     test "#!" != "$(head -c 2 < "$symlink_target")"
708                 then
709                         symlink_target=../valgrind.sh
710                 fi
711                 case "$base" in
712                 *.sh|*.perl)
713                         symlink_target=../unprocessed-script
714                 esac
715                 # create the link, or replace it if it is out of date
716                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
717         }
718
719         # override all git executables in TEST_DIRECTORY/..
720         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
721         mkdir -p "$GIT_VALGRIND"/bin
722         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
723         do
724                 make_valgrind_symlink $file
725         done
726         # special-case the mergetools loadables
727         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
728         OLDIFS=$IFS
729         IFS=:
730         for path in $PATH
731         do
732                 ls "$path"/git-* 2> /dev/null |
733                 while read file
734                 do
735                         make_valgrind_symlink "$file"
736                 done
737         done
738         IFS=$OLDIFS
739         PATH=$GIT_VALGRIND/bin:$PATH
740         GIT_EXEC_PATH=$GIT_VALGRIND/bin
741         export GIT_VALGRIND
742         GIT_VALGRIND_MODE="$valgrind"
743         export GIT_VALGRIND_MODE
744         GIT_VALGRIND_ENABLED=t
745         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
746         export GIT_VALGRIND_ENABLED
747 elif test -n "$GIT_TEST_INSTALLED"
748 then
749         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
750         error "Cannot run git from $GIT_TEST_INSTALLED."
751         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
752         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
753 else # normal case, use ../bin-wrappers only unless $with_dashes:
754         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
755         if ! test -x "$git_bin_dir/git"
756         then
757                 if test -z "$with_dashes"
758                 then
759                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
760                 fi
761                 with_dashes=t
762         fi
763         PATH="$git_bin_dir:$PATH"
764         GIT_EXEC_PATH=$GIT_BUILD_DIR
765         if test -n "$with_dashes"
766         then
767                 PATH="$GIT_BUILD_DIR:$PATH"
768         fi
769 fi
770 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
771 GIT_CONFIG_NOSYSTEM=1
772 GIT_ATTR_NOSYSTEM=1
773 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
774
775 if test -z "$GIT_TEST_CMP"
776 then
777         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
778         then
779                 GIT_TEST_CMP="$DIFF -c"
780         else
781                 GIT_TEST_CMP="$DIFF -u"
782         fi
783 fi
784
785 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
786 export GITPERLLIB
787 test -d "$GIT_BUILD_DIR"/templates/blt || {
788         error "You haven't built things yet, have you?"
789 }
790
791 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
792 then
793         echo >&2 'You need to build test-chmtime:'
794         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
795         exit 1
796 fi
797
798 # Test repository
799 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
800 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
801 case "$TRASH_DIRECTORY" in
802 /*) ;; # absolute path is good
803  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
804 esac
805 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
806 rm -fr "$TRASH_DIRECTORY" || {
807         GIT_EXIT_OK=t
808         echo >&5 "FATAL: Cannot prepare test area"
809         exit 1
810 }
811
812 HOME="$TRASH_DIRECTORY"
813 GNUPGHOME="$HOME/gnupg-home-not-used"
814 export HOME GNUPGHOME
815
816 # run the tput tests *after* changing HOME (in case ncurses needs
817 # ~/.terminfo for $TERM)
818 test -n "${color+set}" || test "x$ORIGINAL_TERM" != "xdumb" && (
819                 TERM=$ORIGINAL_TERM &&
820                 export TERM &&
821                 test -t 1 &&
822                 tput bold >/dev/null 2>&1 &&
823                 tput setaf 1 >/dev/null 2>&1 &&
824                 tput sgr0 >/dev/null 2>&1
825         ) &&
826         color=t
827
828 if test -n "$color"
829 then
830         say_color () {
831                 (
832                 TERM=$ORIGINAL_TERM
833                 export TERM
834                 case "$1" in
835                 error)
836                         tput bold; tput setaf 1;; # bold red
837                 skip)
838                         tput setaf 4;; # blue
839                 warn)
840                         tput setaf 3;; # brown/yellow
841                 pass)
842                         tput setaf 2;; # green
843                 info)
844                         tput setaf 6;; # cyan
845                 *)
846                         test -n "$quiet" && return;;
847                 esac
848                 shift
849                 printf "%s" "$*"
850                 tput sgr0
851                 echo
852                 )
853         }
854 else
855         say_color() {
856                 test -z "$1" && test -n "$quiet" && return
857                 shift
858                 printf "%s\n" "$*"
859         }
860 fi
861
862 if test -z "$TEST_NO_CREATE_REPO"
863 then
864         test_create_repo "$TRASH_DIRECTORY"
865 else
866         mkdir -p "$TRASH_DIRECTORY"
867 fi
868 # Use -P to resolve symlinks in our working directory so that the cwd
869 # in subprocesses like git equals our $PWD (for pathname comparisons).
870 cd -P "$TRASH_DIRECTORY" || exit 1
871
872 this_test=${0##*/}
873 this_test=${this_test%%-*}
874 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
875 then
876         say_color info >&3 "skipping test $this_test altogether"
877         skip_all="skip all tests in $this_test"
878         test_done
879 fi
880
881 # Provide an implementation of the 'yes' utility
882 yes () {
883         if test $# = 0
884         then
885                 y=y
886         else
887                 y="$*"
888         fi
889
890         while echo "$y"
891         do
892                 :
893         done
894 }
895
896 # Fix some commands on Windows
897 case $(uname -s) in
898 *MINGW*)
899         # Windows has its own (incompatible) sort and find
900         sort () {
901                 /usr/bin/sort "$@"
902         }
903         find () {
904                 /usr/bin/find "$@"
905         }
906         sum () {
907                 md5sum "$@"
908         }
909         # git sees Windows-style pwd
910         pwd () {
911                 builtin pwd -W
912         }
913         # no POSIX permissions
914         # backslashes in pathspec are converted to '/'
915         # exec does not inherit the PID
916         test_set_prereq MINGW
917         test_set_prereq NATIVE_CRLF
918         test_set_prereq SED_STRIPS_CR
919         test_set_prereq GREP_STRIPS_CR
920         GIT_TEST_CMP=mingw_test_cmp
921         ;;
922 *CYGWIN*)
923         test_set_prereq POSIXPERM
924         test_set_prereq EXECKEEPSPID
925         test_set_prereq CYGWIN
926         test_set_prereq SED_STRIPS_CR
927         test_set_prereq GREP_STRIPS_CR
928         ;;
929 *)
930         test_set_prereq POSIXPERM
931         test_set_prereq BSLASHPSPEC
932         test_set_prereq EXECKEEPSPID
933         ;;
934 esac
935
936 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
937 test -z "$NO_PERL" && test_set_prereq PERL
938 test -z "$NO_PYTHON" && test_set_prereq PYTHON
939 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
940 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
941
942 # Can we rely on git's output in the C locale?
943 if test -n "$GETTEXT_POISON"
944 then
945         GIT_GETTEXT_POISON=YesPlease
946         export GIT_GETTEXT_POISON
947         test_set_prereq GETTEXT_POISON
948 else
949         test_set_prereq C_LOCALE_OUTPUT
950 fi
951
952 # Use this instead of test_cmp to compare files that contain expected and
953 # actual output from git commands that can be translated.  When running
954 # under GETTEXT_POISON this pretends that the command produced expected
955 # results.
956 test_i18ncmp () {
957         test -n "$GETTEXT_POISON" || test_cmp "$@"
958 }
959
960 # Use this instead of "grep expected-string actual" to see if the
961 # output from a git command that can be translated either contains an
962 # expected string, or does not contain an unwanted one.  When running
963 # under GETTEXT_POISON this pretends that the command produced expected
964 # results.
965 test_i18ngrep () {
966         if test -n "$GETTEXT_POISON"
967         then
968             : # pretend success
969         elif test "x!" = "x$1"
970         then
971                 shift
972                 ! grep "$@"
973         else
974                 grep "$@"
975         fi
976 }
977
978 test_lazy_prereq PIPE '
979         # test whether the filesystem supports FIFOs
980         case $(uname -s) in
981         CYGWIN*)
982                 false
983                 ;;
984         *)
985                 rm -f testfifo && mkfifo testfifo
986                 ;;
987         esac
988 '
989
990 test_lazy_prereq SYMLINKS '
991         # test whether the filesystem supports symbolic links
992         ln -s x y && test -h y
993 '
994
995 test_lazy_prereq FILEMODE '
996         test "$(git config --bool core.filemode)" = true
997 '
998
999 test_lazy_prereq CASE_INSENSITIVE_FS '
1000         echo good >CamelCase &&
1001         echo bad >camelcase &&
1002         test "$(cat CamelCase)" != good
1003 '
1004
1005 test_lazy_prereq UTF8_NFD_TO_NFC '
1006         # check whether FS converts nfd unicode to nfc
1007         auml=$(printf "\303\244")
1008         aumlcdiar=$(printf "\141\314\210")
1009         >"$auml" &&
1010         case "$(echo *)" in
1011         "$aumlcdiar")
1012                 true ;;
1013         *)
1014                 false ;;
1015         esac
1016 '
1017
1018 test_lazy_prereq AUTOIDENT '
1019         sane_unset GIT_AUTHOR_NAME &&
1020         sane_unset GIT_AUTHOR_EMAIL &&
1021         git var GIT_AUTHOR_IDENT
1022 '
1023
1024 test_lazy_prereq EXPENSIVE '
1025         test -n "$GIT_TEST_LONG"
1026 '
1027
1028 test_lazy_prereq USR_BIN_TIME '
1029         test -x /usr/bin/time
1030 '
1031
1032 test_lazy_prereq NOT_ROOT '
1033         uid=$(id -u) &&
1034         test "$uid" != 0
1035 '
1036
1037 # On a filesystem that lacks SANITY, a file can be deleted even if
1038 # the containing directory doesn't have write permissions, or a file
1039 # can be accessed even if the containing directory doesn't have read
1040 # or execute permissions, causing our tests that validate that Git
1041 # works sensibly in such situations.
1042 test_lazy_prereq SANITY '
1043         mkdir SANETESTD.1 SANETESTD.2 &&
1044
1045         chmod +w SANETESTD.1 SANETESTD.2 &&
1046         >SANETESTD.1/x 2>SANETESTD.2/x &&
1047         chmod -w SANETESTD.1 &&
1048         chmod -rx SANETESTD.2 ||
1049         error "bug in test sript: cannot prepare SANETESTD"
1050
1051         ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1052         status=$?
1053
1054         chmod +rwx SANETESTD.1 SANETESTD.2 &&
1055         rm -rf SANETESTD.1 SANETESTD.2 ||
1056         error "bug in test sript: cannot clean SANETESTD"
1057         return $status
1058 '
1059
1060 GIT_UNZIP=${GIT_UNZIP:-unzip}
1061 test_lazy_prereq UNZIP '
1062         "$GIT_UNZIP" -v
1063         test $? -ne 127
1064 '